// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package secretsmanager

const (

	// ErrCodeDecryptionFailure for service response error code
	// "DecryptionFailure".
	//
	// AWS Secrets Manager can't decrypt the protected secret text using the provided
	// KMS key.
	ErrCodeDecryptionFailure = "DecryptionFailure"

	// ErrCodeEncryptionFailure for service response error code
	// "EncryptionFailure".
	//
	// AWS Secrets Manager can't encrypt the protected secret text using the provided
	// KMS key. Check that the customer master key (CMK) is available, enabled,
	// and not in an invalid state. For more information, see How Key State Affects
	// Use of a Customer Master Key (http://docs.aws.amazon.com/kms/latest/developerguide/key-state.html).
	ErrCodeEncryptionFailure = "EncryptionFailure"

	// ErrCodeInternalServiceError for service response error code
	// "InternalServiceError".
	//
	// An error occurred on the server side.
	ErrCodeInternalServiceError = "InternalServiceError"

	// ErrCodeInvalidNextTokenException for service response error code
	// "InvalidNextTokenException".
	//
	// You provided an invalid NextToken value.
	ErrCodeInvalidNextTokenException = "InvalidNextTokenException"

	// ErrCodeInvalidParameterException for service response error code
	// "InvalidParameterException".
	//
	// You provided an invalid value for a parameter.
	ErrCodeInvalidParameterException = "InvalidParameterException"

	// ErrCodeInvalidRequestException for service response error code
	// "InvalidRequestException".
	//
	// You provided a parameter value that is not valid for the current state of
	// the resource. For example, if you try to enable rotation on a secret, you
	// must already have a Lambda function ARN configured or included as a parameter
	// in this call.
	ErrCodeInvalidRequestException = "InvalidRequestException"

	// ErrCodeLimitExceededException for service response error code
	// "LimitExceededException".
	//
	// The request failed because it would exceed one of the AWS Secrets Manager
	// internal limits.
	ErrCodeLimitExceededException = "LimitExceededException"

	// ErrCodeMalformedPolicyDocumentException for service response error code
	// "MalformedPolicyDocumentException".
	//
	// The policy document that you provided isn't valid.
	ErrCodeMalformedPolicyDocumentException = "MalformedPolicyDocumentException"

	// ErrCodeResourceExistsException for service response error code
	// "ResourceExistsException".
	//
	// A resource with the ID you requested already exists.
	ErrCodeResourceExistsException = "ResourceExistsException"

	// ErrCodeResourceNotFoundException for service response error code
	// "ResourceNotFoundException".
	//
	// We can't find the resource that you asked for.
	ErrCodeResourceNotFoundException = "ResourceNotFoundException"
)
